# -*- coding: utf-8 -*-

from aliyunsdkdyiotapi.request.v20171111 import DoIotIsImeiExistRequest
from aliyunsdkdyiotapi.request.v20171111 import DoIotChgBindOrUnBindRequest
from aliyunsdkdyiotapi.request.v20171111 import DoIotPostImeiRequest
from aliyunsdkdyiotapi.request.v20171111 import DoIotRechargeRequest
from aliyunsdkdyiotapi.request.v20171111 import DoIotUserStopResumeRequest
from aliyunsdkdyiotapi.request.v20171111 import DoSendIotSmsRequest
from aliyunsdkdyiotapi.request.v20171111 import QueryCardFlowInfoRequest
from aliyunsdkdyiotapi.request.v20171111 import QueryCardInfoRequest
from aliyunsdkdyiotapi.request.v20171111 import QueryCardStatusRequest
from aliyunsdkdyiotapi.request.v20171111 import QueryIotCardOfferDtlRequest
from aliyunsdkdyiotapi.request.v20171111 import QueryPersonalInfoRequest
from aliyunsdkcore.client import AcsClient
from aliyunsdkcore.profile import region_provider

"""
物联网服务调用接口示例，版本号：v20171111

Created on 2018-04-23

"""

# 注意：不要更改
REGION = "cn-hangzhou"
PRODUCT_NAME = "Dyiotapi"
DOMAIN = "dyiotapi.aliyuncs.com"

# TODO 此处需要替换成开发者自己的AK(在阿里云访问控制台寻找)
ACCESS_KEY_ID = "$yourAccessKeyId"
ACCESS_KEY_SECRET = "$yourAccessKeySecret"

# 初始化acsClient,暂不支持region化
acs_client = AcsClient(ACCESS_KEY_ID, ACCESS_KEY_SECRET, REGION)
region_provider.add_endpoint(PRODUCT_NAME,REGION,DOMAIN)


# 根据iccid查卡信息示例方法
def queryCardInfo_demo(iccid):
    # 组装请求对象 - 具体描述见控制台 - 文档部分内容
    queryCardInfo_request = QueryCardInfoRequest.QueryCardInfoRequest();
    queryCardInfo_request.set_Iccid(iccid);
    # 调用远程接口，返回json
    queryCardInfo_response = acs_client.do_action_with_exception(queryCardInfo_request);
    # TODO 业务处理
    return queryCardInfo_response;

# 根据iccid查卡状态示例方法
def queryCardStatus_demo(iccid):
    # 组装请求对象 - 具体描述见控制台 - 文档部分内容
    queryCardStatus_request = QueryCardStatusRequest.QueryCardStatusRequest();
    queryCardStatus_request.set_Iccid(iccid);
    # 调用远程接口，返回json
    queryCardStatus_response = acs_client.do_action_with_exception(queryCardStatus_request);
    # TODO 业务处理
    return queryCardStatus_response;

# 根据iccid查卡流量信息示例方法
def queryCardFlowInfo_demo(iccid):
    # 组装请求对象 - 具体描述见控制台 - 文档部分内容
    queryCardFlowInfo_request = QueryCardFlowInfoRequest.QueryCardFlowInfoRequest();
    queryCardFlowInfo_request.set_Iccid(iccid);
    # 调用远程接口，返回json
    queryCardFlowInfo_response = acs_client.do_action_with_exception(queryCardFlowInfo_request);
    # TODO 业务处理
    return queryCardFlowInfo_response;


def doIotRecharge_demo(iccid,outId,offerId,effCode,amount):
    # 组装请求对象 - 具体描述见控制台 - 文档部分内容
    doIotRecharge_request = DoIotRechargeRequest.DoIotRechargeRequest();
    doIotRecharge_request.set_OutId("Recharge-"+outId);
    doIotRecharge_request.set_OfferIds(offerId);
    # amount单位MB 目前不支持自定义流量档位
    doIotRecharge_request.set_Amount(amount);
    # 续订 AUTO_ORD
    doIotRecharge_request.set_EffCode(effCode);
    doIotRecharge_request.set_Iccid(iccid);
    # 调用远程接口，返回json
    doIotRecharge_response = acs_client.do_action_with_exception(doIotRecharge_request);
    # TODO 业务处理
    return doIotRecharge_response;

def doIotIsImeiExist_demo(imei):
    # 组装请求对象 - 具体描述见控制台 - 文档部分内容
    doIotIsImeiExist_request = DoIotIsImeiExistRequest.DoIotIsImeiExistRequest();
    # 需要询问的imei
    doIotIsImeiExist_request.set_Imei(imei);
    # 调用远程接口，返回json
    doIotIsImeiExist_response = acs_client.do_action_with_exception(doIotIsImeiExist_request);
    # TODO 业务处理
    return doIotIsImeiExist_response;

def doIotPostImei_demo(imei,deviceType,comments):
    # 组装请求对象 - 具体描述见控制台 - 文档部分内容
    doIotPostImei_request = DoIotPostImeiRequest.DoIotPostImeiRequest();
    # 必填
    doIotPostImei_request.set_Imei(imei);
    # 设备类型（非必填）
    doIotPostImei_request.set_DeviceType(deviceType);
    # 备注（非必填）
    doIotPostImei_request.set_Comments(comments);
    # 调用远程接口，返回json
    doIotPostImei_response = acs_client.do_action_with_exception(doIotPostImei_request);
    # TODO 业务处理
    return doIotPostImei_response;

def doIotUserStopResume_demo(iccid,actionName):
    # 组装请求对象 - 具体描述见控制台 - 文档部分内容
    doIotUserStopResume_request = DoIotUserStopResumeRequest.DoIotUserStopResumeRequest();
    # 必填
    doIotUserStopResume_request.set_Iccid(iccid);
    # 必填  管理复机 MANAGE_RESUME、管理停机 MANAGE_STOP
    doIotUserStopResume_request.set_OptionType(actionName);
    # 调用远程接口，返回json
    doIotUserStopResume_response = acs_client.do_action_with_exception(doIotUserStopResume_request);
    # TODO 业务处理
    return doIotUserStopResume_response;

def doIotChgBindOrUnBind_demo(iccid,imei,newimei,optionType):
    # 组装请求对象 - 具体描述见控制台 - 文档部分内容
    doIotChgBindOrUnBind_request = DoIotChgBindOrUnBindRequest.DoIotChgBindOrUnBindRequest();
    # 必填
    doIotChgBindOrUnBind_request.set_Iccid(iccid);
    # 必填
    doIotChgBindOrUnBind_request.set_Imei(imei);
    # chgBind：换绑；unBind：解绑
    doIotChgBindOrUnBind_request.set_OpionType(optionType);
    # 当是换绑的时候 此字段必填
    doIotChgBindOrUnBind_request.set_NewImei(newimei);
    # 调用远程接口，返回json
    doIotChgBindOrUnBind_response = acs_client.do_action_with_exception(doIotChgBindOrUnBind_request);
    # TODO 业务处理
    return doIotChgBindOrUnBind_response;

def doSendIotSms_demo(recNum,signName,templateCode,templateParam):
    # 组装请求对象 - 具体描述见控制台 - 文档部分内容
    doSendIotSms_request = DoSendIotSmsRequest.DoSendIotSmsRequest();
    # 签名
    doSendIotSms_request.set_SignName(signName);
    # 接收号码
    doSendIotSms_request.set_PhoneNumbers(recNum);
    # 模板编号
    doSendIotSms_request.set_TemplateCode(templateCode);
    # 短信内容参数
    doSendIotSms_request.set_TemplateParam(templateParam);
    # 调用远程接口，返回json
    doSendIotSms_response = acs_client.do_action_with_exception(doSendIotSms_request);
    # TODO 业务处理
    return doSendIotSms_response;

def qryPersonalInfo_demo(iccid):
    # 组装请求对象 - 具体描述见控制台 - 文档部分内容
    qryPersonalInfo_request = QueryPersonalInfoRequest.QueryPersonalInfoRequest();
    # 必填
    qryPersonalInfo_request.set_Iccid(iccid);
    # 调用远程接口，返回json
    qryPersonalInfo_response = acs_client.do_action_with_exception(qryPersonalInfo_request);
    # TODO 业务处理
    return qryPersonalInfo_response;

def qryIotCardOfferDtl_demo(iccid):
    # 组装请求对象 - 具体描述见控制台 - 文档部分内容
    qryIotCardOfferDtl_request = QueryIotCardOfferDtlRequest.QueryIotCardOfferDtlRequest();
    # 必填
    qryIotCardOfferDtl_request.set_Iccid(iccid);
    # 调用远程接口，返回json
    qryIotCardOfferDtl_response = acs_client.do_action_with_exception(qryIotCardOfferDtl_request);
    # TODO 业务处理
    return qryIotCardOfferDtl_response;


# 测试
__name__ = 'queryCardInfo_demo'
if __name__ == 'queryCardInfo_demo':
    print queryCardInfo_demo("iccid");

if __name__ == 'queryCardStatus_demo':
    print queryCardStatus_demo("iccid");

if __name__ == 'queryCardFlowInfo_demo':
    print queryCardFlowInfo_demo("iccid");

if __name__ == 'doIotRecharge_demo':
    print doIotRecharge_demo("iccid","outId","offerId","effCode","amount");

if __name__ == 'doIotIsImeiExist_demo':
    print doIotIsImeiExist_demo("imei");

if __name__ == 'doIotPostImei_demo':
    print doIotPostImei_demo("imei","deviceType","comments");

if __name__ == 'doIotUserStopResume_demo':
    print doIotUserStopResume_demo("iccid","actionName");

if __name__ == 'doIotChgBindOrUnBind_demo':
    print doIotChgBindOrUnBind_demo("iccid","imei","newimei","optionType");

if __name__ == 'doSendIotSms_demo':
    print doSendIotSms_demo("recNum","signName","templateCode","templateParam");

if __name__ == 'qryPersonalInfo_demo':
    print qryPersonalInfo_demo("iccid");

if __name__ == 'qryIotCardOfferDtl_demo':
    print qryIotCardOfferDtl_demo("iccid");